VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Sleep - Inactive"
   ClientHeight    =   2880
   ClientLeft      =   3780
   ClientTop       =   2550
   ClientWidth     =   5385
   LinkTopic       =   "Form1"
   ScaleHeight     =   2880
   ScaleWidth      =   5385
   Begin VB.CommandButton cmdEdit 
      Caption         =   "Activate"
      Height          =   375
      Left            =   3960
      TabIndex        =   9
      Top             =   480
      Width           =   1095
   End
   Begin VB.CheckBox chkForce 
      Caption         =   "Force Shutdown"
      Height          =   255
      Left            =   2280
      TabIndex        =   8
      ToolTipText     =   "When checked the shutwod ist forced even if there is unsaved data in other applications!"
      Top             =   2040
      Width           =   2055
   End
   Begin VB.CheckBox chkActive 
      Caption         =   "Do Shutdown"
      Height          =   255
      Left            =   600
      TabIndex        =   7
      ToolTipText     =   "Without this box checked nothing will happen."
      Top             =   2040
      Value           =   1  'Checked
      Width           =   1575
   End
   Begin VB.CommandButton cmd90 
      Caption         =   "90"
      Height          =   255
      Left            =   3240
      TabIndex        =   6
      Top             =   1560
      Width           =   495
   End
   Begin VB.CommandButton cmd60 
      Caption         =   "60"
      Height          =   255
      Left            =   2640
      TabIndex        =   5
      Top             =   1560
      Width           =   495
   End
   Begin VB.CommandButton cmd30 
      Caption         =   "30"
      Height          =   255
      Left            =   2040
      TabIndex        =   4
      Top             =   1560
      Width           =   495
   End
   Begin VB.TextBox txtShutdownIn 
      Height          =   375
      Left            =   2040
      TabIndex        =   2
      Top             =   1080
      Width           =   1695
   End
   Begin VB.TextBox txtShutdownAt 
      Height          =   375
      Left            =   2040
      TabIndex        =   0
      Top             =   480
      Width           =   1695
   End
   Begin VB.Timer timMain 
      Interval        =   10000
      Left            =   0
      Top             =   360
   End
   Begin VB.Label Label3 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "This utility was developed by Philipp Stiefel <phil@codekabinett.de>"
      Height          =   255
      Left            =   0
      TabIndex        =   10
      Top             =   2640
      Width           =   5415
   End
   Begin VB.Label Label2 
      Caption         =   "Shutdown in: (minutes)"
      Height          =   375
      Left            =   600
      TabIndex        =   3
      Top             =   1080
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Shutdown at:"
      Height          =   375
      Left            =   600
      TabIndex        =   1
      Top             =   480
      Width           =   1455
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private blnAutoShutDown As Boolean

Private Sub cmd30_Click()
   Me.txtShutdownAt.Text = DateAdd("n", 30, Now)
End Sub

Private Sub cmd60_Click()
    Me.txtShutdownAt.Text = DateAdd("n", 60, Now)
End Sub

Private Sub cmd90_Click()
    Me.txtShutdownAt.Text = DateAdd("n", 90, Now)
End Sub

Private Sub cmdEdit_Click()
On Error Resume Next

    Dim ctl As Control
    
    For Each ctl In Me.Controls
        If ctl.Name <> Me.cmdEdit.Name _
            And ctl.Name <> Me.timMain.Name _
        Then
            ctl.Enabled = Not ctl.Enabled
        End If
    Next ctl
    
    If Me.txtShutdownAt.Enabled Then
        Me.cmdEdit.Caption = "Activate"
        Me.Caption = "Sleep - Inactive"
    Else
        Me.cmdEdit.Caption = "Edit"
        Me.Caption = "Sleep - Activated"
    End If
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
On Error GoTo Form_Unload_Err

    If Not blnAutoShutDown Then
        If MsgBox("Do you really want to disable the Sleep-Functionality?", vbQuestion Or vbYesNo) = vbNo Then
            Cancel = True
        End If
    End If
    
Exit Sub
Form_Unload_Err:
    Call RuntimeError

End Sub

Private Sub timMain_Timer()

    If Len(Me.txtShutdownAt.Text) > 0 _
        And IsDate(Me.txtShutdownAt.Text) _
        And Not Me.txtShutdownAt.Enabled _
    Then
        If CDate(Me.txtShutdownAt.Text) <= Now _
            And CBool(Me.chkActive.Value) = True _
        Then
            blnAutoShutDown = True
            Call ShutDown(CBool(Me.chkForce.Value))
        End If
            
        Me.Caption = "Sleep - Shutdown scheduled in " & DateDiff("n", Now, CDate(Me.txtShutdownAt.Text)) & " minutes..."
    Else
        Me.Caption = "Sleep - no valid date/time in 'Shutdown at'."
    End If
    
End Sub

Private Sub txtShutdownAt_Validate(Cancel As Boolean)
On Error GoTo txtShutdownAt_Validate_Err

    If Len(Me.txtShutdownAt.Text) > 0 Then
        If Not IsDate(Me.txtShutdownAt.Text) Then
            MsgBox "No valid Date/Time!"
            Cancel = True
        End If
    End If
    
Exit Sub
txtShutdownAt_Validate_Err:
    Call RuntimeError
    
End Sub


Private Sub txtShutdownIn_Validate(Cancel As Boolean)
On Error GoTo txtShutdownIn_Validate_Err

    If Len(Me.txtShutdownIn.Text) > 0 Then
        If Not IsNumeric(Me.txtShutdownIn.Text) Then
            MsgBox "No valid Timespan!"
            Cancel = True
        Else
            Me.txtShutdownAt.Text = DateAdd("n", CDbl(Me.txtShutdownIn.Text), Now)
        End If
    End If
    
    
Exit Sub
txtShutdownIn_Validate_Err:
    Call RuntimeError
End Sub
